﻿using HarmonyLib;
using System.Collections.Generic;
using thmsn.CraftFromAllStorage.Patches;
using Steamworks;
using System;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Text;
using System.Threading.Tasks;
using UnityEngine;
using Sirenix.Serialization;

namespace thmsn.CraftFromAllStorage.Network
{
    public static class NetworkMessageProcessor
    {
        public static List<Message> waiting = new List<Message>();

        public static Packet_Single DeserializeFragmentedPacket(Raft_Network.Message_FragmentedPacket fragment) => Traverse.Create(ComponentManager<Raft_Network>.Value).Method("DeserializeFragmentedPacket", fragment).GetValue() as Packet_Single;


        public static bool ProcessMessage(Message message)
        {
            switch (message.Type)
            {
                case Message_Storage_Small_AdditionalData.MESSAGE_TYPE:
                    if (CraftFromAllStorageMod.worldLoaded)
                        Message_Storage_Small_AdditionalData.HandleAdditionalData(message as Message_Storage_Small_AdditionalData);
                    else
                        waiting.Add(message);
                    break;
                case Message_Storage_Small_AnimateOpen.MESSAGE_TYPE:
                    if (CraftFromAllStorageMod.worldLoaded)
                        Message_Storage_Small_AnimateOpen.HandleNetworkMessage(message as Message_Storage_Small_AnimateOpen);
                    else
                        waiting.Add(message);
                    break;
                case Message_Storage_Small_AnimateClose.MESSAGE_TYPE:
                    if (CraftFromAllStorageMod.worldLoaded)
                        Message_Storage_Small_AnimateClose.HandleNetworkMessage(message as Message_Storage_Small_AnimateClose);
                    else
                        waiting.Add(message);
                    break;
                default:
                    return false;
            }
            return true;
        }

        
    }

    [HarmonyPatch(typeof(GameManager), "OnWorldRecievedLate")]
    class Patch_OnWorldRecievedLate
    {
        static void Postfix()
        {
            CraftFromAllStorageMod.worldLoaded = true;

            if (NetworkMessageProcessor.waiting.Count > 0)
            {
                foreach (var message in NetworkMessageProcessor.waiting)
                {
                    NetworkMessageProcessor.ProcessMessage(message);
                }

                NetworkMessageProcessor.waiting.Clear();
            }
        }
    }

}