﻿using HarmonyLib;
using Steamworks;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using thmsn.CraftFromAllStorage.Extensions;
using thmsn.CraftFromAllStorage.Network;
using UnityEngine;

namespace thmsn.CraftFromAllStorage.Patches
{

    /* The flow of storage, OnIsRayed triggers a Message_Storage when you interact with the storage, 
     * if you are the host, it also calls this.storageManager.OpenStorage(this); causing your inventory to open.
     */

    /// <summary>
    /// Patch RemoveItem so fuel can be removed from storage as well as the players inventory.
    /// this.cookingPot.localPlayer.Inventory.RemoveItem(this.cookingPot.Fuel.fuelItem.UniqueName, fuel);
    /// </summary>
    [HarmonyPatch(typeof(Inventory), nameof(Inventory.RemoveItem), typeof(string), typeof(int))]
    class Patch_PlayerInventory_RemoveItem
    {
        static void Prefix(Inventory __instance, string uniqueItemName, ref int amount)
        {
            if (__instance && __instance is PlayerInventory playerInventory)
                playerInventory.RemoveItemFromInventoryAndStoragesOnRaft(uniqueItemName, ref amount, false);
        }
    }
}