﻿using HarmonyLib;
using Steamworks;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using thmsn.CraftFromAllStorage.Extensions;
using thmsn.CraftFromAllStorage.Network;
using UnityEngine;

namespace thmsn.CraftFromAllStorage.Patches
{

    /// <summary>
    /// Auto Recipe Redux triggers CookingTable_Slot.OnInsertItem, 
    /// this uses CookingTable_Slot.OnSlotInsertItem that calls CookingTable_Slot.InsertItem 
    /// that calls RemoveItemUses in player inventory.
    /// 
    /// </summary>
    [HarmonyPatch(typeof(Inventory), nameof(Inventory.RemoveItemUses), typeof(string), typeof(int), typeof(bool))]
    class Patch_PlayerInventory_RemoveItemUses
    {
        static void Prefix(Inventory __instance, string uniqueItemName, ref int usesToRemove, bool addItemAfterUseToInventory = true)
        {
            if (__instance && __instance is PlayerInventory playerInventory)
                playerInventory.RemoveItemFromInventoryAndStoragesOnRaft(uniqueItemName, ref usesToRemove, false);
        }
    }
}